{$R-,S-} {$ifdef FPC} {$mode tp} {$endif}

program db; {public domain, free for any use, nenies proprajho}

const maxline: integer = 16; show_offset: boolean = true;
var f: file of byte; fname: string;

procedure writehex(l: longint; w: integer);
const table:string[16]='0123456789ABCDEF'; hex:string[8]='00000000';
var i:integer;
begin
  for i := 8 downto 1 do begin
    hex[i] := table[(l and $0F)+1];
    l := l shr 4
  end;
  if w=8 then write(hex) else write(copy(hex,8-w+1,w))
end; {writehex}

procedure getarg;
var num,errpos: integer;
const usagemsg = 'Usage:  db.exe [-q] myfile.dat' +
                 ' [number_of_bytes_per_line]';

  procedure grab(n: integer);
  begin fname := paramstr(n);
    val(paramstr(n+1),num,errpos); if errpos=0 then maxline := num
  end; {grab}

  function quiet: boolean; var s: string;
  begin s := paramstr(1);
    quiet := ((s[1]='-') or (s[1]='/')) and (upcase(s[2])='Q')
  end; {quiet}

begin
  case paramcount of
    0: begin writeln(usagemsg); halt(255) end;
    1: begin fname := paramstr(1) end;
    2: begin
         if quiet then begin
           show_offset := false; fname := paramstr(2)
         end
         else grab(1)
       end;
    3: begin
         if quiet then begin show_offset := false; grab(2) end
         else grab(1)
       end;
  end
end; {getarg}

procedure dump(name: string);
var b: byte; c: longint;
begin c := 0;
  while not eof(f) do begin
    if ((c = 0) or (c mod maxline = 0)) and show_offset then begin
      writehex(c,8); write(': ')
    end;
    read(f,b); writehex(b,2); inc(c);
    if c mod maxline = 0 then
      writeln
    else if not eof(f) then
      write(' ');
  end
end; {dump}

begin {main} getarg; assign(f,fname);
  filemode := 0; {$I-} reset(f); {$I+}
  if IOresult=0 then begin
    dump(fname); close(f); writeln
  end
  else begin
    writeln('''',fname,''' not found!');
    halt(1)
  end
end.
